
import java.applet.Applet;
import java.awt.*;
import java.awt.image.MemoryImageSource;

/**
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: Aug 2, 2003
 * Time: 12:06:27 AM
 * To change this template use Options | File Templates.
 */
public class Plasma extends Applet implements Runnable {
    private int width;
    private int height;
    private int width2;
    private int height2;
    private int[] pixels;
    private int[] plasma;
    private int[] lookup;
    private int[] firstTable;
    private int[] secondTable;
    private Image image;
    private MemoryImageSource imageSource;
    private boolean painted;

    private double r1, r2, r3, r4, r5, r6, r7, r8;

    public int getWidth() {
	return getSize().width;
    }

    public int getHieght() {
	return getSize().height;
    }

    public void update(Graphics g) {
        paint(g);
    }

    public void paint(Graphics g) {
        g.drawImage(image, 0, 0, this);
        painted = true;
    }

    public void init() {
        super.init();
        width2 = getWidth() / 2;
        height2 = getHeight() / 2;
        width = width2*2;
        height = height2*2;
        pixels = new int[width * height];
        imageSource = new MemoryImageSource(width, height, pixels, 0, width);
        imageSource.setAnimated(true);
        imageSource.setFullBufferUpdates(true);
        image = createImage(imageSource);
        plasma = new int[width2 * height2];
        lookup = new int [256*4];
        firstTable = new int [width * height];
        secondTable = new int [width * height];
        for (int i = 0; i < 256; i++) {
            int red = 0*Math.abs(255 - i * 2);
            int green =0* Math.abs(255 - i * 2);
            int blue = Math.abs(255 - i * 2);
            int color = 0xFF000000 + (red << 16) + (green << 8) + (blue);
            lookup[i] = lookup[i + 256] = lookup [i + 512] = lookup[i + 768] = color;
        }
        final double scale = Math.sqrt(height2*height2+width2*width2);
        int index = 0;
        for (int y = -height2; y < height2; y++) {
            for (int x = -width2; x < width2; x++) {
                double dist = Math.sqrt(x*x+y*y) / scale;
                firstTable[index] = (int)(dist * 256);
                secondTable[index] = (int)(Math.sin(dist * Math.PI * 4) * 127 + 128);
                index++;
            }
        }
        new Thread(this).start();
    }

    public void stop() {
        super.stop();
    }

    public void start() {
        super.start();
    }

    private void updatePlasma() {
        int x1, y1, x2, y2, x3, y3, x4, y4;
        x1 = (int) (Math.cos(r1) * width2 + width2)/2;
        y1 = (int) (Math.sin(r2) * height2 + height2)/2;
        x2 = (int) (Math.cos(r3) * width2 + width2)/2;
        y2 = (int) (Math.sin(r4) * height2 + height2)/2;
        x3 = (int) (Math.cos(r5) * width2 + width2)/2;
        y3 = (int) (Math.sin(r6) * height2 + height2)/2;
        x4 = (int) (Math.cos(r7) * width2 + width2)/2;
        y4 = (int) (Math.sin(r8) * height2 + height2)/2;
        r1 += Math.PI / 256 * 2;
        r2 += Math.PI / 256 * 5;
        r3 -= Math.PI / 256 * 3;
        r4 += Math.PI / 256 * 4;
        r5 += Math.PI / 256 * 3;
        r6 -= Math.PI / 256 * 7;
        r7 -= Math.PI / 256 * 4;
        r8 += Math.PI / 256 * 2;
        int destindex = 0;
        int index1 = x1 + y1 * width;
        int index2 = x2 + y2 * width;
        int index3 = x3 + y3 * width;
        int index4 = x4 + y4 * width;
        for (int y = 0; y < height2; y++) {
            for (int x = 0; x < width2; x++) {
                plasma[destindex++] =
                        firstTable[index1++] +
                        secondTable[index2++] +
                        secondTable[index3++] +
                        secondTable[index4++];
            }
            index1 += width - width2;
            index2 += width - width2;
            index3 += width - width2;
            index4 += width - width2;
        }
        destindex = 0;
        int srcindex = 0;
        for (int y = 0; y < height2; y++) {
            for (int x = 0; x < width2; x++) {
                int color = lookup[plasma[srcindex++]];
                pixels[destindex+width] = color;
                pixels[destindex++] = color;
                pixels[destindex+width] = color;
                pixels[destindex++] = color;
            }
            destindex += width;
        }

        painted = false;
        imageSource.newPixels();
    }

    public void run() {
        while (true) {
            updatePlasma();
            while (!painted)
                ;
        }
    }
}
